<template>
  <div>
    <section class="secondary">
      <v-container>
        <div>
          <SearchBar @search="handleSearch" :query="searchQuery" />
        </div>
      </v-container>
    </section>
    <section>
      <v-container>
        <v-subheader class="d-flex justify-space-between" v-if="!searchLoading && pros.length">
          <div>
            {{totalResults}} résultats pour "{{searchQuery}}"
          </div>
          <div>
            page {{currentPage}}/{{totalPages}}
          </div>
        </v-subheader>
        <div v-if="searchLoading">
          <v-card class="mb-5 d-flex flex-row" v-for="index in 1" elevation="0" :key="index">
            <v-skeleton-loader
              type="list-item-avatar-two-line, list-item-three-line, card-heading"
              class="ma-5 w-100"
            ></v-skeleton-loader>
            <v-skeleton-loader
              type="list-item-two-line, list-item-two-line, list-item-two-line"
              class="ma-5 w-100"
            ></v-skeleton-loader>
          </v-card>
        </div>

        <v-card v-else class="pa-4 mb-5" v-for="(pro, index) in pros" elevation="0" :key="index">
          <v-row align="center">
            <v-col
              cols="12"
              sm="6"
              class="text-center"
              >
              <div class="d-flex flex-column flex-md-row align-center justify-center align-md-start align-top">
                <v-avatar
                  size="80"
                  class="secondary"
                  >
                    <img
                      v-if="pro.avatar"
                      alt="Avatar"
                      :src="pro.avatar"
                    >
                    <span class="white--text text-h5" v-else>{{pro.lastName | firstChar}}{{pro.firstName | firstChar}}</span>
                </v-avatar>
                <div>
                  <v-list-item two-line>
                    <v-list-item-content>
                      <v-list-item-title class="title">
                        <router-link :to="{name: 'Professional', params: { id: pro.id }}">{{pro.firstName}} {{pro.lastName}}</router-link>
                      </v-list-item-title>
                      <v-list-item-subtitle>{{pro.job}}</v-list-item-subtitle>
                    </v-list-item-content>
                  </v-list-item>
                </div>
              </div>
              <div>
                <v-btn :to="{name: 'Professional', params: {id: pro.id}}" class="mt-3" depressed>
                  Plus d'infos
                </v-btn>
              </div>
            </v-col>
            <v-col cols="12" sm="6" class=" text-center text-md-left">
              <v-list-item three-line v-for="(office, index) in pro.offices" :key="index">
                <v-list-item-content>
                  <v-list-item-title><router-link :to="{name: 'Office', params: { officeId: office.id }}">{{office.name}}</router-link></v-list-item-title>
                  <v-list-item-subtitle>
                    {{office.address}}
                  </v-list-item-subtitle>
                  <v-list-item-subtitle>
                    {{office.postalCode}} {{office.city}}
                  </v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
            </v-col>
          </v-row>
        </v-card>

        <div class="text-center" v-if="totalPages > 1">
          <v-pagination 
            :value="currentPage"
            :length="totalPages"
            @input="changePage"
            :disabled="searchLoading"
          ></v-pagination>
        </div>

        <div v-if="!pros.length && !searchLoading">
          <v-row align="center">
            <v-col
              cols="12"
              sm="6"
              >
              <v-img src="@/assets/svg/no-results.svg" width="150" class="mx-auto mb-5"/>
            </v-col>
            <v-col
              cols="12"
              sm="6"
              class="text-sm-left text-center"
              >
              <p class="text-h4">Oups.. </p>
              <p class="text-h5">Aucun résultat trouvé</p>
            </v-col>
          </v-row>
        </div>
      </v-container>
    </section>
  </div>
</template>

<script>
import SearchBar from "@/components/SearchBar";

export default {
  name: 'Search',
  components: {
    SearchBar,
  },
  data() {
    return {
      searchLoading: true,
      pros: [],
      totalResults: 0,
      totalPages: 0,
      itemsPerPage: 20,
    }
  },
  computed: {
    searchQuery(){
      return this.$route.query.q ?? '';
    },
    currentPage(){
      return this.$route.query.page ? parseInt(this.$route.query.page) : 1;
    }
  },
  methods: {
    changePage(newPage){

      if(this.currentPage == newPage)
        return;
      
      this.$router.push({query: {q: this.searchQuery, page: newPage}});
      this.search();
    },
    handleSearch(query){
      if(this.$route.query.q == query)
        return;

      this.totalPages = 0;
      this.$router.push({query: {q: query}});
      this.search();
    },
    goWithDate: function(id, office, date, slot){
      this.$router.push({name: 'Professional', params: { id: id, office: office, date: date, slot: slot}});
    },
    search(){
      this.searchLoading = true;

      this.$apiRest.get('/users?roles=PRO&search='+this.searchQuery+'&page='+this.currentPage+'&itemsPerPage='+this.itemsPerPage)
        .then(res => {
            this.pros = res.data['hydra:member'];

            this.totalResults = res.data['hydra:totalItems'];
            this.totalPages = Math.ceil(res.data['hydra:totalItems'] / this.itemsPerPage);
            
            this.searchLoading = false;
        })
    }
  },
  mounted(){
    this.search();
  },
  filters: {
    firstChar: function (value) {
      if(!value) return '';
      return value.charAt(0);
    }
  }
}
</script>
